/**
 * @description calls cloud function
 * @param functions you want to make callable
 * @param name of the cloud function
 * @param params you want to set
 */
import { Functions } from '@angular/fire/functions';
export declare function callFunction<C extends Record<string, (...args: any) => any>, N extends Extract<keyof C, string>>(functions: Functions, name: N, params?: Parameters<C[N]>): Promise<ReturnType<C[N]>>;
